# B2F5_SmartLuggageTracker-18

Deze code is geschreven voor een LoRa-gebaseerde gps-tracker. De tracker is gemaakt met een Adafruit M0 LoRa.

## Materialen
- Adafruit Feather M0 LoRa 900MHz
- GP20u7 gps-module
- Ijzerdraad/ijzerstaafje (minimaal 8,2cm)
- Kabeltje (minimaal 5 centimeter)

## Verbindingen
Sluit de hardware als volgt aan:

![hardware](https://i.imgur.com/bLTF7u6.png)
 
De antenne in bovenstaande tekening wordt gemaakt met de ijzerdraad/ijzerstaaf en **moet** precies 8,2cm lang zijn. **Let op!** Bij de GP20u7 gps-module moet de adapter worden afgeknipt, zodat de drie kabels los kunnen worden aangesloten zoals in de afbeelding. 

Als alles goed is aangesloten, hoort de tracker eruit te zien zoals in onderstaande afbeelding (de kabel van pin 9 naar IO1 zit aan de onderkant en is dus niet goed te zien).

![hardware](https://i.imgur.com/xQIYWRd.jpg)
 
## Configuratie Arduino IDE
Hieronder zal worden toegelicht hoe de Arduino IDE moet worden ingesteld.

### Installeren van de boards
Ga in de Arduino IDE naar File > Preferences. Voer bij More Board Managers URLs deze link in: https://adafruit.github.io/arduino-board-index/package_adafruit_index.json

Ga in de Arduino IDE naar Tools > Board > Boards manager. Installeer vanaf hier de volgende boards:
- Arduino SAMD Boards (32-bits ARM Cortex-M0+)
- Adafruit SAMD Boards

De Adafruit M0 kan nu worden geselecteerd door op Tools > Board > Adafruit SAMD > Adafruit Feather M0 te klikken. Als dit bord niet geselecteerd kan worden, herstart dan eerst de Arduino IDE

### Installeren van de libraries
Er moeten twee libraries geïnstalleerd worden. Één hiervan handmatig, de ander via de Arduino IDE.

- Voor de eerste library, de GP20U7 GPS Library, ga je naar Tools > Manage Libraries en installeer je de GP20U7 GPS Library.
- Voor de andere library, de Arduino-LMIC library, open je [deze link](https://github.com/huebe/arduino-lmic). Klik op Code > Download ZIP. Pak deze zip uit en kopieer deze naar documents\Arduino\libraries.

## Code uploaden
Alles is nu klaar om te uploaden. Download de code hier van GitHub en open deze met de Arduino IDE. Er zijn nog 3 variablen die aangepast moeten worden. Dit zijn de waardes waardoor de Adafruit weet waar de data naartoe moet worden gestuurd.

### The Things Network
Het LoRa-netwerk wat gebruikt zal worden is het netwerk van [The Things Network (TTN)](https://www.thethingsnetwork.org/). Maak hier eerst een account aan. Ga vervolgens naar Console > Applications > Add application. Geef de applicatie hier een herkenbare naam en klik op Add application. Klik nu onder devices op Register device. Geef bij Device ID een herkenbare naam in en laat de Device EUI door The Things Network genereren door op het icoontje op het begin van de regel te klikken. Klik daarna op Register. Kopieer nu de volgende waardes voor de volgende variablen:
- Application EUI naar APPEUI (in lsb-formaat)
- Device EUI naar DEVEUI (in lsb-formaat)
- App Key naar APPKEY (in msb-formaat)

Om het formaat van de waardes in het goede formaat te krijgen, kan in The Thing Network de weergave van de waardes worden aangepast door op de icoontjes aan het begin van de regel te klikken.

De data die binnen zal komen bij The Things Network moet nog worden omgezet naar leesbare tekst. Ga daarvoor bij The Things Network naar Applications > [jouw applicatie] > Payload Format. Plak hier de volgende code:
```
function Decoder(bytes, port) {
  return {
    coords: String.fromCharCode.apply(null, bytes)
  };
}
```
Klik vervolgens op save payload functions.

### De laatste stap
Sluit nu de Adafruit aan op je laptop/pc en upload de code (wellicht dat je eerst bij Tools > Port de juiste poort moet selecteren). Na een paar minuten zou er data moeten verschijnen bij The Things Network onder het tabje Data. 

## Oplossen van problemen

Verschijnt er geen data? Controleer dan in de Seriële Monitor (Arduino IDE > Tools > Serial Monitor) of "EV_TXCOMPLETE (includes waiting for RX windows)" verschijnt. Dit betekent dat data wordt verzonden. Verschijnt er alleen "EV_JOINING" maar verder niets? Dan kan het zijn dat je te ver weg bent van een LoRa-antenne van The Things Network en geen verbinding kan worden gemaakt.

Verschijnt er "FAILURE" in de console? Reset dan de Adafruit, sluit de Adafruit opnieuw aan op je laptop/desktop en herstart de Arduino IDE. Upload vervolgens de code opnieuw.

Kan de tracker de gps-locatie niet ophalen? Wacht dan iets langer. Dit kan soms erg lang duren, tot wel een kwartier. Het gps-bereik binnen is sowieso minder goed. 
